# sitelib for noarch packages, sitearch for others (remove the unneeded one)
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_version: %define python_version %(%{__python} -c "import sys; print sys.version[0:3]")}

Name:           rainbow
Version:        0.8.6
Release:        2%{?dist}
Summary:        An isolation shell

Group:          System Environment/Daemons
License:        MIT
URL:            http://wiki.laptop.org/go/Rainbow
Source0:        http://dev.laptop.org/~mstone/releases/SOURCES/%{name}-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       python
Requires:       xorg-x11-server-Xephyr
Requires:       xorg-x11-xauth
BuildRequires:  python-devel
BuildRequires:  python-setuptools

%description
An isolation shell based on the Bitfrost threat model.

%prep
%setup -q


%build
make \
	CFLAGS="%{optflags}" \
	%{?_smp_mflags} 


%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
make install \
	DESTDIR="$RPM_BUILD_ROOT" \
	SBINDIR="$RPM_BUILD_ROOT/%{_sbindir}" \
	BINDIR="$RPM_BUILD_ROOT/%{_bindir}" \
	LIBDIR="$RPM_BUILD_ROOT/%{_lib}" \
	SYSCONFDIR="$RPM_BUILD_ROOT/%{_sysconfdir}" \
	LOCALSTATEDIR="$RPM_BUILD_ROOT/%{_localstatedir}" \
	CFLAGS="%{optflags}" \
	%{?_smp_mflags}



%post -p /sbin/ldconfig


%postun -p /sbin/ldconfig


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/security/console.perms.d/51-rainbow.perms
%doc README COPYING AUTHORS
%{python_sitelib}/*
%{_bindir}/rainbow-run
%{_bindir}/rainbow-sugarize
%{_bindir}/rainbow-xify
%{_bindir}/rainbow-easy
%{_bindir}/rainbow-gc
%{_bindir}/rainbow-resume
%{_bindir}/mkenvdir
%dir %{_localstatedir}/spool/rainbow
/%{_lib}/libnss_rainbow.so.2

%changelog
* Thu Jul 22 2010 David Malcolm <dmalcolm@redhat.com> - 0.8.6-2
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Mon Dec 21 2009 Michael Stone <michael@laptop.org> - 0.8.6-1
- Michael Stone (many):
    Helpers for resume and gc.
    Bug fixes.
    ...

* Mon Nov 30 2009 Michael Stone <michael@laptop.org> - 0.8.5-2
- rhbz#542699: build with %%{optflags}

* Sat Nov 28 2009 Michael Stone <michael@laptop.org> - 0.8.5-1
- Michael Stone (many):
    Outline network and X11 isolation strategies.
    Support multiple owning users.
    ...

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Dec 17 2008 Bernie Innocenti <bernie@codewiz.org> - 0.8.1-1.olpc3
- Michael Stone (many):
    Implement an NSS plugin and CLI for rainbow.
- Bernie Innocenti (many):
    Motivate Michael and merge the nss-rainbow code.

* Tue Sep 16 2008 Michael Stone <michael@laptop.org> - 0.7.24-1.olpc3
- Michael Stone (1):
    Apply the _get_lang() checks to the correct variable.

* Tue Sep 16 2008 Michael Stone <michael@laptop.org> - 0.7.23-1.olpc3
- Sayamindu Dasgupta (1):
    dlo#8127: Strip double-quotes in _get_lang().

* Fri Sep 12 2008 Michael Stone <michael@laptop.org> - 0.7.22-1.olpc3
- Michael Stone (1):
    dlo#8434: Add a use-serial permission.

* Fri Sep 05 2008 Michael Stone <michael@laptop.org> - 0.7.21-1.olpc3
- Michael Stone (1):
    Move the permissions.info file into the activity directory.

* Tue Sep 02 2008 Michael Stone <michael@laptop.org> - 0.7.20-1.olpc3
- Michael Stone (6):
    dlo#7921: Read ~/.i18n and set $LANG before importing gtk.
    Always call setgroups().
    dlo#6465: Make a 'constant-uid' bundle permission.
    Ensure that $HOME exists regardless of what useradd tells you.
    Make the instance directory setgid.
    Clean /home/olpc/.i18n before passing its contents to arbitrary uid-0 code.
- Simon Schampijer (1):
    dlo#5428: downloads not starting in Browse due to old compreg.dat

* Mon Aug 04 2008 Michael Stone <michael@laptop.org> - 0.7.19-1.olpc3
- Michael Stone (1):
    Adjust the rainbow startup and logging logic.

* Sat Aug 02 2008 Michael Stone <michael@laptop.org> - 0.7.18-1.olpc3
- Bobby Powers (1):
    dlo#6797: Fix module preloading on F9-based builds.
- C. Scott Ananian (1):
    The sugar session.info file was removed; don't try to inject it.
- Michael Stone (1):
    Drop the rainbow initscript.

* Mon Jul 24 2008 Michael Stone <michael@laptop.org> - 0.7.17-1.olpc3
- Michael Stone (1):
    dlo#7587: Make logging and pid-file writing optional.

* Mon Jul 24 2008 Michael Stone <michael@laptop.org> - 0.7.16-1.olpc3
- C. Scott Ananian (2):
    Update Makefile.fedora to be kinder to cross-building from debian systems.
    dlo#317: Adjust location of XAUTHORITY and ICEAUTHORITY files.

* Mon Jul 21 2008 Michael Stone <michael@laptop.org> - 0.7.15-1.olpc3
- Martin Dengler (1):
    Fix '/etc/init.d/rainbow status'.
- Tomeu Vizoso (1):
    dlo#7574 Copy .ICEauthority to $HOME.

* Mon Jun 25 2008 Michael Stone <michael@laptop.org> - 0.7.14-1.olpc3
- Daniel Drake (1):
    dlo#7302, dlo#7294: Make the audio and video device nodes have mode 0666.
- Michael Stone (1):
    Begin building in the OLPC-3 buildroot.

* Mon May 26 2008 Michael Stone <michael@laptop.org> - 0.7.13-1.olpc2
- Fix dlo#6989 - beware of contract violations induced by CONSTANT_UID +
  instance==home.

* Mon May 05 2008 Michael Stone <michael@laptop.org> - 0.7.12-1.olpc2
- Hack around a failing gtk import by trying to lose the race with X. (bsetlow)
- Detect, log, and work around errors that occur during module preloading. (mstone)
- Make $SAR/instance <- $HOME. (mstone)

* Thu Mar 24 2008 Michael Stone <michael@laptop.org> - 0.7.11-1.olpc2
- Merge tomeu's common module preloading patch.
- Merge patchvonbraun's group-permissions work.
- Make rainbow daemonize faster.

* Tue Feb 13 2008 Michael Stone <michael@laptop.org> - 0.7.10-1.olpc2
- Symlink ~/{.macromedia,.adobe} -> ~/.instance to ease
  http://dev.laptop.org/ticket/6411

* Thu Jan 31 2008 Michael Stone <michael@laptop.org> - 0.7.9-1.olpc2
- Relax the size restrictions on the tmpfsen that Rainbow mounts for
  activities.
- Symlink ~/.fontconfig -> ~/.instance to ease
  http://dev.laptop.org/ticket/6046
- Rework build scripts to use mock for snapshot builds.
- Normalize the package name to lower case everywhere.

* Fri Jan 11 2008 Michael Stone <michael@laptop.org> - 0.7.8-1.olpc2
- Teach rainbow to respond to Sugar requests to use a fixed uid for the bundle
  being launched.

* Wed Jan 09 2008 Michael Stone <michael@laptop.org> - 0.7.7-1.olpc2
- Provide a spool-gc library for boot-time resource reclamation. (may be racy).
  Addresses http://dev.laptop.org/ticket/{5637,2527}
- Close unblessed file descriptors before activity launch.
- Turn on logrotate for /var/log/rainbow.
- Remove bitrotted configuration file.

* Fri Jan 04 2008 Michael Stone <michael@laptop.org> - 0.7.6-1.olpc2
- Move Rainbow's spool-dir from /activities to $HOME/isolation/1/; works
  around http://dev.laptop.org/ticket/5033
- Provide a spool-replay script for use by olpc-configure.
- Construct spools at run-time rather than via rpm.
- Remove our runtime-dependency on python-setuptools.

* Wed Dec 19 2007 Michael Stone <michael@laptop.org> - 0.7.5-1.olpc2
- Install /etc/olpc-security by default.
- Improve installation-scripts to handle updates. (thanks, Mako).
- Cause rainbow-daemon to request utf8 strings, fixes http://dev.laptop.org/ticket/5011.

* Sat Nov 10 2007 Michael Stone <michael@laptop.org> - 0.7.4-1.olpc2
- Explicitly specify the working directory of launched activities.
- Reduce permissions on activity home dirs.
- Fix the strace option.
- Add ipython dependency so we get detailed tracebacks on failure.
- Make owner.key.pub available to activities.

* Wed Nov 07 2007 Michael Stone <michael@laptop.org> - 0.7.3-1.olpc2
- Replace Rainbow's log dir with a log file.
- Put Rainbow's spool into /activities since we're making /var/run and /var/tmp
  into tmpfsen.

* Mon Nov 05 2007 Michael Stone <michael@laptop.org> - 0.7.2-1.olpc2
- Tell Sugar when we think we've successfully launched activities.

* Mon Nov 05 2007 Michael Stone <michael@laptop.org> - 0.7.1-1.olpc2
- Add rainbow-inject hook for console tests.
- Improve error-detection.
- Explicitly take ownership for all the dirs in Rainbow's spool.
- Reap zombie children.
- Add explicit dependency on an appropriate sugar version.

* Thu Nov 01 2007 Michael Stone <michael@laptop.org> - 0.7.0-1.olpc2
- Remove olpc-update
- Remove dependency on pyvserver

* Thu Sep 27 2007 Michael Stone <michael@laptop.org> - 0.6.7-1
- Add /etc/init.d/rainbow-daemon

* Thu Sep 27 2007 Michael Stone <michael@laptop.org> - 0.6.6-1
- Bump revision number.

* Mon Sep 24 2007 Michael Stone <michael@laptop.org> - 0.6.5-1
- Bump revision number.

* Mon Sep 24 2007 Michael Stone <michael@laptop.org> - 0.6.4-1
- Bump revision number.
- Add dependency on olpccontents

* Wed Sep 19 2007 Michael Stone <michael@laptop.org> - 0.6.3-1
- Fix version/release numbering.
- Correct source line.

* Wed Sep 19 2007 Michael Stone <michael@laptop.org> - 1.0-0.6.2
- Bump revision number.
- Fix installation permissions on executable scripts.
- Add a olpc-update and olpc-update-rsync scripts for performing incremental OS
  updates.

* Mon Sep 10 2007 Michael Stone <michael@laptop.org> - 1.0-0.6.1
- Bump revision number.

* Fri Sep 07 2007 Michael Stone <michael@laptop.org> - 1.0-0.6
- Correct ChangeLog formatting.

* Thu Aug 31 2007 Michael Stone <michael@laptop.org> - 1.0-0.4.4.20070831gita7c737
- Record run-time dependencies on python-sqlalchemy and pyvserver.
- Add a build-number field to the release identifier.

* Thu Aug 30 2007 Michael Stone <michael@laptop.org> - 1.0-0.2.20070830git014607
- Add a new installed binary for runninng updaters.

* Mon Aug 13 2007 Noah Kantrowitz <noah@laptop.org> - 1.0-0.2.20070731gitde262e
- Add dist tag to Release.

* Mon Aug 13 2007 Noah Kantrowitz <noah@laptop.org> - 1.0-0.1.20070731gitde262e
- Remove arch-specific variables.
- Package only needed folders from site-pacakges.
- Use macros in a few more places.

* Tue Jul 31 2007 Noah Kantrowitz <noah@laptop.org> - 1.0-0.0.20070731gitde262e
- Bump to latest version of Rainbow.

* Mon Jul 30 2007 Noah Kantrowitz <noah@laptop.org> - 1.0-0.0.20070730git9a7744
- Adding DBus session bus config and bumping to new snapshop of Rainbow.

* Tue Jul 24 2007 Noah Kantrowitz <noah@laptop.org> - 1.0-0.0.20070723git639686
- Initial version of this spec.
